//рисуем канат


//Функция описывающая прядь

//Include "pryadi_nd.inc" ;



Function Rope 

//переменные для вычисления точек и дуг предыдущей окружности
pp = 18 ; pr = 66 ; fig = 35 ; 
ugpp1 = 2*Pi/3;  //угол поворота точки относительно оси пряди

//Рисуем Канат:
kls = 4; //Колличество свивок
nt = kls*6; //(6)Столько элементарных объемов будет нарисовано в каждой пряде
sl = 0; nslpp = 1 ;

Include "NDEFEKT.INC";

//цикл для отрисовки первых окружностей
For np In {1:6}
    ugp = (6-np)*Pi/3;  //угол поворота точки относительно оси пряди
//Первая окружность
    p1[np] = newp; Point(p1[np]) = {xc,yc,zc,lck};
    Rotate { {1,0,0},{kx,ky,kz},ugp } {Point{p1[np]}; }
    p2[np] = newp; Point(p2[np]) = {xc,yc+rp,zc,lck};
    Rotate { {1,0,0},{xc,yc,zc},ugpp1 } {Point{p2[np]}; }  
    Rotate { {1,0,0},{kx,ky,kz},ugp } {Point{p2[np]}; }

    p3[np] = newp; Point(p3[np]) = {xc,yc+rp,zc,lck};
    Rotate { {1,0,0},{xc,yc,zc},-ugpp1/6 } {Point{p3[np]}; }  
    Rotate { {1,0,0},{kx,ky,kz},ugp } {Point{p3[np]}; }
    nnp[np] = np + 1;
EndFor
   
nnp[6] = 1 ;

For np In {1:6}

   c1[np] = newreg; Circle(c1[np]) = {p2[np],p1[np],p3[np]};
   Transfinite Line{c1[np]} = kolp1 ;
   nnnr = c1[np];
   c2[np] = newreg; Circle(c2[np]) = {p3[np],p1[np],p2[nnp[np]]};
   Transfinite Line{c2[np]} = kolp1 ;
   c3[np] = newreg; Circle(c3[np]) = {p2[nnp[np]],p1[np],p2[np]};
   Transfinite Line{c3[np]} = kolp1 ;
EndFor

For np In {1:6}
   l1[np] = newreg; Line Loop(l1[np]) = {c1[np],c2[np],c3[np]} ;
   s1[np] = newreg; Plane Surface(s1[np]) = {l1[np]} ;
EndFor

      ficha = newreg+fig ; Line(ficha) = {p2[np],p1[np]}; 
   //фиктивная линия для подгонки номеров объектов,
   //автоматически образуемых в цикле

   //первая торцевая поверхность пряди 
   slp1[sl]=s1[1] ;  //список поверхностей описывающих прядь каната
   slp2[sl]=s1[2] ;  //список поверхностей описывающих прядь каната
   slp3[sl]=s1[3] ;  //список поверхностей описывающих прядь каната
   slp4[sl]=s1[4] ;  //список поверхностей описывающих прядь каната
   slp5[sl]=s1[5] ;  //список поверхностей описывающих прядь каната
   slp6[sl]=s1[6] ;  //список поверхностей описывающих прядь каната

   
   For n In {1:nt}

     hx1 = n*dk/6;  //приращение по Х
     ug = n*Pi/18;  //угол поворота точки относительно оси каната

     //Следующая окружность
     //новые точки
     For np In {1:6}
        ugp = (6-np)*Pi/3;  //угол поворота точки относительно оси каната

        p21[np] = newp; Point(p21[np]) = {xc+hx1+1,yc,zc,lck};
        Rotate { {1,0,0},{kx+hx1+1,ky,kz},ug } {Point{p21[np]}; }
        Translate {-1,0,0} {Point{p21[np]}; }
        Rotate { {1,0,0},{kx+hx1+1,ky,kz},ugp } {Point{p21[np]}; }

        p22[np] = newp; Point(p22[np]) = {xc+hx1+1,yc+rp,zc,lck};
        Rotate { {1,0,0},{xc+hx1+1,yc,zc},ugpp1 } {Point{p22[np]}; }  
        Rotate { {1,0,0},{kx+hx1+1,ky,kz},ug } {Point{p22[np]}; }
        Translate {-1,0,0} {Point{p22[np]}; }
        Rotate { {1,0,0},{kx+hx1+1,ky,kz},ugp } {Point{p22[np]}; }

        p23[np] = newp; Point(p23[np]) = {xc+hx1+1,yc+rp,zc,lck};
        Rotate { {1,0,0},{xc,yc,zc},-ugpp1/6 } {Point{p23[np]}; }  
        Rotate { {1,0,0},{kx+hx1+1,ky,kz},ug } {Point{p23[np]}; }
        Translate {-1,0,0} {Point{p23[np]}; }
        Rotate { {1,0,0},{kx+hx1+1,ky,kz},ugp } {Point{p23[np]}; }
        nnp[np] = np + 1;
     EndFor

        nnp[6] = 1 ;

     For np In {1:6}
        c21[np] = newreg; Circle(c21[np]) = {p22[np],p21[np],p23[np]};
        Transfinite Line{c21[np]} = kolp1 ;
        c22[np] = newreg; Circle(c22[np]) = {p23[np],p21[np],p22[nnp[np]]};
        Transfinite Line{c22[np]} = kolp1 ;
        c23[np] = newreg; Circle(c23[np]) = {p22[nnp[np]],p21[np],p22[np]};
        Transfinite Line{c23[np]} = kolp1 ;
     EndFor

     For np In {1:6}
        //Срединяем предыдущую окружность с последующей
        If ( n==1+(nt/2) )
          l2[np] = newreg; Line(l2[np]) = {p22[np]-pp,p22[np]};
//          Transfinite Line{l2[np]} = kolp2*2 ;
	  l3[np] = newreg; Line(l3[np]) = {p23[np]-pp,p23[np]};
//          Transfinite Line{l3[np]} = kolp2*2 ;
	EndIf
        If ( n!=1+(nt/2) )
          l2[np] = newreg; Line(l2[np]) = {p22[np]-pp,p22[np]};
          Transfinite Line{l2[np]} = kolp2 ;
	  l3[np] = newreg; Line(l3[np]) = {p23[np]-pp,p23[np]};
          Transfinite Line{l3[np]} = kolp2 ;
	EndIf

     EndFor

     For np In {1:6}
        //Описываем боковые поверхности пряди
       If (np == npsd && n == 1 + (nt/2))
        l4[np] = newreg; Line Loop(l4[np]) = {c21[np]-pr,l3[np],-c21[np],-l2[np]} ;
        s4[np] = newreg; Ruled Surface(s4[np]) = {l4[np],ldl1} ;
//        Transfinite Surface{s4[np]} = {p22[np]-pp,p23[np]-pp,p23[np],p22[np]} ;
       EndIf
       If (np != npsd || n != 1 + (nt/2))
        l4[np] = newreg; Line Loop(l4[np]) = {c21[np]-pr,l3[np],-c21[np],-l2[np]} ;
        s4[np] = newreg; Ruled Surface(s4[np]) = {l4[np]} ;
        Transfinite Surface {s4[np]} = {p22[np]-pp,p23[np]-pp,p23[np],p22[np]} ;
       EndIf

        l5[np] = newreg; Line Loop(l5[np]) = {c22[np]-pr,l2[nnp[np]],-c22[np],-l3[np]} ;
        s5[np] = newreg; Ruled Surface(s5[np]) = {l5[np]} ;
        Transfinite Surface {s5[np]} = {p23[np]-pp,p22[nnp[np]]-pp,p22[nnp[np]],p23[np]} ;

        l6[np] = newreg; Line Loop(l6[np]) = {c23[np]-pr,l2[np],-c23[np],-l2[nnp[np]]} ;
        s6[np] = newreg; Ruled Surface(s6[np]) = {l6[np]} ;
        Transfinite Surface {s6[np]} = {p22[nnp[np]]-pp,p22[np]-pp,p22[np],p22[nnp[np]]} ;

     EndFor

     sl = sl+1 ; 
     slp1[sl] = s4[1] ; slp2[sl] = s4[2] ; slp3[sl] = s4[3] ;
     slp4[sl] = s4[4] ; slp5[sl] = s4[5] ; slp6[sl] = s4[6] ;
     sl = sl+1 ; 
     slp1[sl] = s5[1] ; slp2[sl] = s5[2] ; slp3[sl] = s5[3] ;
     slp4[sl] = s5[4] ; slp5[sl] = s5[5] ; slp6[sl] = s5[6] ;
     sl = sl+1 ; 
     slp1[sl] = s6[1] ; slp2[sl] = s6[2] ; slp3[sl] = s6[3] ;
     slp4[sl] = s6[4] ; slp5[sl] = s6[5] ; slp6[sl] = s6[6] ;
 
  EndFor

  Delete { Line{ficha}; }
     //описываем плоскую поверхность ограниченную дугами


     For np In {1:6}
        l21[np] = newreg; Line Loop(l21[np]) = {c21[np],c22[np],c23[np]} ;
        s21[np] = newreg; Plane Surface(s21[np]) = {l21[np]} ;
     EndFor

   sl = sl+1 ; 
   slp1[sl]=s21[1]; slp2[sl]=s21[2]; slp3[sl]=s21[3];
   slp4[sl]=s21[4]; slp5[sl]=s21[5]; slp6[sl]=s21[6];
   sl = sl+1 ;
   If (npsd == 1)
     slp1[sl]=sd1;
   EndIf
   If (npsd == 2)
     slp2[sl]=sd1;
   EndIf
   If (npsd == 3)
     slp3[sl]=sd1;
   EndIf
   If (npsd == 4)
     slp4[sl]=sd1;
   EndIf
   If (npsd == 5)
     slp5[sl]=sd1;
   EndIf
   If (npsd == 6)
     slp6[sl]=sd1;
   EndIf

Return //конец процедуры





xc = kx ; yc = ky+rcp ; zc = kz ;
pv = rp*Sin(Pi/4) ;


Call Rope ;

   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp1[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp2[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp3[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp4[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp5[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp6[]};

slpp[0] = newreg;
Surface Loop(slpp[0]) = {bs1,bs2,bs3,bs4,bs5,bs6};
bv1 = newreg; Volume(bv1) = {slpp[]};

   If (npsd == 1)
     slp1[sl]=sd3;
     sl = sl+1 ;  slp1[sl]=sd4;
     sl = sl+1 ;  slp1[sl]=sd5;
     sl = sl+1 ;  slp1[sl]=sd6;
     sl = sl+1 ;  slp1[sl]=sd7;
   EndIf
   If (npsd == 2)
     slp2[sl]=sd3;
     sl = sl+1 ;  slp2[sl]=sd4;
     sl = sl+1 ;  slp2[sl]=sd5;
     sl = sl+1 ;  slp2[sl]=sd6;
     sl = sl+1 ;  slp2[sl]=sd7;
   EndIf
   If (npsd == 3)
     slp3[sl]=sd3;
     sl = sl+1 ;  slp3[sl]=sd4;
     sl = sl+1 ;  slp3[sl]=sd5;
     sl = sl+1 ;  slp3[sl]=sd6;
     sl = sl+1 ;  slp3[sl]=sd7;
   EndIf
   If (npsd == 4)
     slp4[sl]=sd3;
     sl = sl+1 ;  slp4[sl]=sd4;
     sl = sl+1 ;  slp4[sl]=sd5;
     sl = sl+1 ;  slp4[sl]=sd6;
     sl = sl+1 ;  slp4[sl]=sd7;
   EndIf
   If (npsd == 5)
     slp5[sl]=sd3;
     sl = sl+1 ;  slp5[sl]=sd4;
     sl = sl+1 ;  slp5[sl]=sd5;
     sl = sl+1 ;  slp5[sl]=sd6;
     sl = sl+1 ;  slp5[sl]=sd7;
   EndIf
   If (npsd == 6)
     slp6[sl]=sd3;
     sl = sl+1 ;  slp6[sl]=sd4;
     sl = sl+1 ;  slp6[sl]=sd5;
     sl = sl+1 ;  slp6[sl]=sd6;
     sl = sl+1 ;  slp6[sl]=sd7;
   EndIf
 
  ppls = 0 ;
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp1[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp2[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp3[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp4[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp5[]};
   ppls++;
   slpp[ppls] = newreg; Surface Loop(slpp[ppls]) = {slp6[]};


For np In {ppls-5:ppls}
  vp[np] = newreg; Volume(vp[np]) = {slpp[np]} ;
EndFor

For np In {1:6}
  Physical Volume(100000+np) = {vp[np]};  //Пряди каната
EndFor

